//-------------------------------------------------------------------------------
// abasic.h
//-------------------------------------------------------------------------------

#if !defined(__ABASIC_)
#define __ABASIC_

#include "./common.h"
#include "./calc.h"
#include "./vari.h"
#include "./variant.h"
#include "./variant_io.h"
#include "./st_inst.h"


#define EVAL			0x80000000
#define IF				0x20000000

//MAX 0xFF ʂɂ荶8Vtg
#define NOTHING		0x01

#define FOR				0x10
#define NEXT			0x11
#define GOTO			0x12
#define FUNC			0x13
#define RETURN			0x14
#define INPUT			0x15
#define OUTPUT			0x16
#define PRINT			0x17
#define CLR				0x18
#define LOCATION		0x19
#define SLEEP			0x1A
#define ABS				0x1B
#define INT				0x1C
#define SHELL			0x1D
#define LEN				0x1E
#define MID				0x1F
#define VAL				0x20
#define STR				0x21
#define CSV				0x22
#define CHOP			0x23
#define REPLACE			0x24
#define MATCH			0x25
#define VSC				0x26
#define ABASIC_FREAD	0x27
#define ABASIC_FWRITE	0x28
#define IF2				0x29
#define ELSE			0x2A
#define ENDIF			0x2B
#define TRIM			0x2C
#define LTRIM			0x2D
#define RTRIM			0x2E
#define LCASE			0x2F
#define UCASE			0x30
#define LEFT			0x31
#define RIGHT			0x32
#define JIS				0x33
#define ASC				0x34
#define INSTR			0x35
#define BLOCK_			0x36
#define _BLOCK			0x37
#define FORMAT			0x38
//lZ----------------------
#define SQRT			0xA1
#define _EXP			0xA2
#define LOG10			0xA3
#define LOG				0xA4
#define SIN				0xA5
#define COS				0xA6
#define TAN				0xA7
#define ASIN			0xA8
#define ACOS			0xA9
#define ATAN			0xAA
//------------------------------
#define EXP				0xFE
#define MASK			0xFF


extern unsigned int p_counter; //vOJE^
extern std::map<std::string,std::string> variable_table;//̃}bv
extern std::vector<std::string> source; //basic̃vOi[z

int basic_init(char*filename);
void basic_setup();
void basic_start(int);
void basic_end();

void source_init();
void source_add(char*str,int line);
void source_end();

#endif

//-------------------------------------------------------------------------------
